<?php



function multicrud_example_ingredients_form(&$form_state) {
  $description = <<<EOT
      <p>Ingredients repository. Values are saved to the session.</p>
EOT;
  $form = array();
  $form['description'] = array(
    '#type' => 'markup',
    '#value' => $description,
  );
  $form['ingredients'] = array(
    '#type' => 'multicrud',
    '#multicrud_elements' => array(
      'title' => array(
        '#title' => 'Ingredient name',
        '#type' => 'textfield',
        '#size' => 30,
      ),
      'description' => array(
        '#title' => 'Description',
        '#type' => 'textarea',
        '#rows' => 2,
        '#resizable' => false,
        '#cols' => 30,
      ),
    ),
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save',
  );
  
  $form['ingredients']['#default_value'] = _multicrud_example_session_get('ingredients');
  return $form;
}


function multicrud_example_ingredients_form_submit($form, &$form_state) {
  $submitHandler = new _multicrud_example_ingredients_SubmitHandler();
  multicrud_submit($form['ingredients'], $form_state['values']['ingredients'], $submitHandler);
  return;
  
  $ingredients = _multicrud_example_session_get('ingredients');
  $items = $form_state['values']['ingredients']['items'];
  $delete_keys = $form_state['values']['ingredients']['delete'];
  $m = array();
  if (is_array($delete_keys)) {
    foreach ($delete_keys as &$key) {
      if (preg_match('/^existing-(\d+)$/', $key, $m)) {
        $id = (int)$m[1];
        unset($ingredients[$id]);
        unset($items[$key]);
      }
    }
  }
  if (is_array($items)) {
    foreach ($items as $key => $item) {
      if (preg_match('/^existing-(\d+)$/', $key, $m)) {
        $id = (int)$m[1];
        $ingredients[$id] = array(
          'title' => $item['title'],
          'description' => $item['description'],
        );
      } else if (preg_match('/^new\d+$/', $key)) {
        if (!empty($item['title'])) {
          $ingredients[] = array(
            'title' => $item['title'],
            'description' => $item['description'],
          );
        }
      }
    }
  }
  _multicrud_example_session_set('ingredients', $ingredients);
}



class _multicrud_example_ingredients_SubmitHandler extends multicrud_SubmitHandler {
  protected $_ingredients;
  
  public function __construct() {
    $this->_ingredients = _multicrud_example_session_get('ingredients');
  }
  
  public function deleteItem($id) {
    if (isset($this->_ingredients[$id])) {
      unset($this->_ingredients[$id]);
      return TRUE;
    } else {
      return FALSE;
    }
  }
  
  public function flushDelete() {
    // 
  }
  
  public function updateItem($id, $item, $meta) {
    if (isset($this->_ingredients[$id])) {
      $this->_ingredients[$id]['title'] = $item['title'];
      $this->_ingredients[$id]['description'] = $item['description'];
      $this->_ingredients[$id]['weight'] = $meta['weight'];
      $this->_ingredients[$id]['parent'] = $meta['parent'];
    }
  }
  
  public function insertItem($item, $meta) {
    $this->_ingredients[] = array(
      'title' => $item_values['title'],
      'description' => $item_values['description'],
      'weight' => $meta['weight'],
      'parent' => $meta['parent'],
    );
    return count($this->_ingredients) - 1;
  }
  
  public function flush() {
    _multicrud_example_session_set('ingredients', $this->_ingredients);
  }
}





