<?php



function multicrud_example_menu_form(&$form_state) {
  $description = <<<EOT
      <p>Menu demo form. Values are saved to the session.</p>
EOT;
  $form = array();
  $form['description'] = array(
    '#type' => 'markup',
    '#value' => $description,
  );
  $form['menu'] = array(
    '#type' => 'multicrud',
    '#multicrud_elements' => array(
      'title' => array(
        '#title' => 'Title',
        '#type' => 'textfield',
        '#size' => 30,
      ),
      'path' => array(
        '#title' => 'Path',
        '#type' => 'textfield',
        '#size' => 30,
      ),
      'enabled' => array(
        '#title' => 'Enabled',
        '#type' => 'checkbox',
      ),
      'expanded' => array(
        '#title' => 'Expanded',
        '#type' => 'checkbox',
      ),
      'description' => array(
        '#title' => 'Description',
        '#type' => 'textarea',
        '#rows' => 2,
        '#resizable' => false,
        '#cols' => 30,
      ),
    ),
    '#multicrud_empty_values' => array(
      'path' => '<new>',
      'enabled' => true,
    ),
    '#multicrud' => array(
      'weight_key' => 'weight',
      'parent_key' => 'plid',
    ),
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save',
  );
  
  $form['menu']['#default_value'] = _multicrud_example_session_get('menu');
  
  $test = array('x' => 'X', 'y' => 'Y');

  return $form;
}


function multicrud_example_menu_form_submit($form, &$form_state) {
  $submitHandler = new _multicrud_example_menu_SubmitHandler();
  multicrud_submit($form['menu'], $form_state['values']['menu'], $submitHandler);
}



class _multicrud_example_menu_SubmitHandler extends multicrud_SubmitHandler {
  protected $_menu;
  
  public function __construct() {
    $this->_menu = _multicrud_example_session_get('menu');
  }
  
  public function deleteItem($id) {
    if (isset($this->_menu[$id])) {
      unset($this->_menu[$id]);
      return TRUE;
    } else {
      return FALSE;
    }
  }
  
  public function flushDelete() {
    // dpm($this->_menu);
  }
  
  public function updateItem($id, $item, $meta) {
    if (isset($this->_menu[$id])) {
      $this->_menu[$id] = $item;
    }
  }
  
  public function insertItem($item, $meta) {
    return $this->_array_push($this->_menu, $item);
  }
  
  public function flush() {
    // dpm($this->_menu);
    _multicrud_example_session_set('menu', $this->_menu);
  }
}





