<?php



function multicrud_example_ingredient_usage_form(&$form_state) {
  $description = <<<EOT
      <p>Recipe for a fancy cake. Values are saved to the session.</p>
EOT;
  $form = array();
  $form['description'] = array(
    '#type' => 'markup',
    '#value' => $description,
  );
  $form['ingredient_usage'] = array(
    '#type' => 'multicrud',
    '#multicrud_elements' => array(
      'ingredient_id' => array(
        '#title' => 'Ingredient',
        '#type' => 'select',
        '#options' => array(),
      ),
      'amount' => array(
        '#title' => 'Amount',
        '#type' => 'textfield',
        '#size' => 10,
      ),
    ),
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save',
  );
  
  $ingredient_options = array(0 => ' - ');
  foreach (_multicrud_example_session_get('ingredients') as $id => $ingredient) {
    $ingredient_options[$id] = $ingredient['title'];
  }
  $form['ingredient_usage']['#multicrud_elements']['ingredient_id']['#options'] = $ingredient_options;
  
  $form['ingredient_usage']['#default_value'] = _multicrud_example_session_get('ingredient_usage');
  
  return $form;
}

function multicrud_example_ingredient_usage_form_submit($form, &$form_state) {
  $ingredient_usage = _multicrud_example_session_get('ingredient_usage');
  dpm($form_state['values']);
  $items = $form_state['values']['ingredient_usage']['items'];
  $delete_keys = $form_state['values']['ingredient_usage']['delete'];
  $m = array();
  if (is_array($delete_keys)) {
    foreach ($delete_keys as &$key) {
      if (preg_match('/^existing-(\d+)$/', $key, $m)) {
        $id = (int)$m[1];
        unset($ingredient_usage[$id]);
        unset($items[$key]);
      }
    }
  }
  if (is_array($items)) {
    foreach ($items as $key => $item) {
      if (preg_match('/^existing-(\d+)$/', $key, $m)) {
        $id = (int)$m[1];
        $ingredient_usage[$id] = array(
          'ingredient_id' => $item['ingredient_id'],
          'amount' => $item['amount'],
        );
      } else if (preg_match('/^new\d+$/', $key)) {
        if (!empty($item['ingredient_id'])) {
          $ingredient_usage[] = array(
            'ingredient_id' => $item['ingredient_id'],
            'amount' => $item['amount'],
          );
        }
      }
    }
  }
  _multicrud_example_session_set('ingredient_usage', $ingredient_usage);
}

