<?php



function multicrud_example_form(&$form_state) {
  $description = <<<EOT
      <p>Ingredients for a fancy cake.</p>
EOT;
  $form = array();
  $form['description'] = array(
    '#type' => 'markup',
    '#value' => $description,
  );
  $form['ingredients'] = array(
    '#type' => 'multicrud',
    '#multicrud_elements' => array(
      'ingredient_name' => array(
        '#title' => 'Ingredient name',
        '#type' => 'textfield',
        '#size' => 30,
      ),
      'amount' => array(
        '#title' => 'Amount',
        '#type' => 'textfield',
        '#size' => 10,
        '#element_validate' => array('_multicrud_example_amount_validate'),
      ),
    ),
    '#default_value' => array(
      'flour' => array('ingredient_name' => 'Flour', 'amount' => '500 g'),
      'milk' => array('ingredient_name' => 'Milk' , 'amount' => '0,2 l'),
      'sugar' => array('ingredient_name' => 'Sugar', 'amount' => '35 g' ),
    ),
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save',
  );
  return $form;
}

function multicrud_example_form_submit($form, &$form_state) {
  dpm($form_state['values']);
}

function _multicrud_example_amount_validate($element, &$form_state) {dpm(__FUNCTION__);dpm($element);
  if (!preg_match('/^\d+/', $element['#value'])) {
    form_error($element, t('Please define an amount.'));
  }
}




