
Drupal.multicrud.newTableDrag = function(table, options) {
  
  var tableDrag = new Drupal.tableDrag(table, options);
  
  tableDrag.findDropTargetRow = function(x, y) {
    dropTargetRow = Drupal.tableDrag.prototype.findDropTargetRow.apply(this,[x,y]);
    if (''+y == 'NaN') {
      x.foo();
    }
    // console.log('findDropTargetRow '+x+' '+y);
    if (!$(dropTargetRow).next().size()) {
      return $(dropTargetRow).prev();
    }
    return dropTargetRow;
  };
  
  /*
  tableDrag.updateFields = function(changedRow) {
    console ? console.log('changedRow: ', changedRow) : null;
    try {
      Drupal.tableDrag.prototype.updateFields.apply(this, [changedRow]);
    } catch (e) {
      console.log('error ', e);
    }
  };
  */
  
  tableDrag.onDrop = function() {
    table.multicrud.pruneRows();
    return null;
  };
  
  tableDrag.rowSettings = function(group, row) {
    // console.log('group: ' + group + ', row: ' + row);
    var field = $('.' + group, row);
    for (delta in this.tableSettings[group]) {
      var targetClass = this.tableSettings[group][delta]['target'];
      if (field.is('.' + targetClass)) {
        // Return a copy of the row settings.
        var rowSettings = new Object();
        for (var n in this.tableSettings[group][delta]) {
          rowSettings[n] = this.tableSettings[group][delta][n];
        }
        return rowSettings;
      }
    }
  };
  
  tableDrag.getMouseOffset = function(target, event) {
    var docPos   = this.getPosition(target);
    var mousePos = this.mouseCoords(event);
    // console.log('getMouseOffset', $(target)[0], docPos, mousePos);
    return {x:mousePos.x - docPos.x, y:mousePos.y - docPos.y};
  };
  
  return tableDrag;
};

$(document).ready(function(){
  
  // add tabledrag
  $('tbody.multicrud-tbody').each(function(){
    var table = this.parentNode;
    var multicrud_info = table.multicrud.getInfo();
    // console.log('multicrud_info', multicrud_info);
    var tbody = this;
    if (!multicrud_info.options.weights) {
      return;
    }
    var row_keeper = this.multicrud;
    var id = $(table).attr('id');
    
    var tabledrag_options = {};
    
    if (multicrud_info.options.parents) {
      tabledrag_options['multicrud-parent'] = [{
        target:"multicrud-parent",
        source:"multicrud-id",
        relationship:"parent",
        action:"match",
        hidden:false,
        limit:0
      }];
    }
    
    tabledrag_options['multicrud-weight'] = [{
      target:"multicrud-weight",
      source:"multicrud-weight",
      relationship:"sibling",
      action:"order",
      hidden:false,
      limit:0
    }];
    
    // console.log(tabledrag_options);
    
    var parent_map = [];
    var indent_map = [];
    
    $('input.multicrud-id').each(function(){
      var item_key = $(this).val();
      $('input.multicrud-parent', this.parentNode).each(function(){
        var parent_item_key = $(this).val();
        parent_map[item_key] = parent_item_key;
      });
    });
    
    
    var fillIndentMap = function(item_key) {
      if (indent_map[item_key] != undefined) {
        // do nothing..
      } else if (parent_map[item_key] == undefined || parent_map[item_key] == null || parent_map[item_key] == '') {
        indent_map[item_key] = 0;
      } else {
        indent_map[item_key] = fillIndentMap(parent_map[item_key]) + 1;
      }
      return indent_map[item_key];
    };
    
    $('thead tr', table).each(function(){
      $('<th class="drag"></th>').prependTo(this);
    });
    $('tfoot tr, tbody tr', table).each(function(){
      $('<td class="drag"></td>').prependTo(this);
    });
    
    // console.log(parent_map);
    
    $('tbody input.multicrud-id', table).each(function(){
      var tr = $(this).parents('tr')[0];
      var item_key = $(this).val();
      var indent = fillIndentMap(item_key);
      // console.log(tr, indent);
      var indentHtml = '';
      for (var i=0; i<indent; ++i) {
        indentHtml += '<div class="indentation">&nbsp;</div>';
      }
      // indentHtml += '<a class="tabledrag-handle" href="#" title="Drag to re-order"><div class="handle">&nbsp;</div></a>';
      $('td.drag', tr).append(indentHtml);
    });
    
    var tableDrag;
    
    row_keeper.addListener(new (function(){
      this.initRow = function(tr) {
        // console.log('solidifyRow listener');
        if (!tableDrag) {
          $('tr', tbody).removeClass('draggable');
          $(tr).addClass('draggable');
          // tr will be the first and only draggable row.
          // console.log('++ drag construct', $(tr)[0]);
          tableDrag = Drupal.multicrud.newTableDrag(tbody.parentNode, tabledrag_options);
        } else {
          if (!$(tr).is('.draggable')) {
            $(tr).addClass('draggable');
            // console.log('++ drag solidify', $(tr)[0]);
            tableDrag.makeDraggable($(tr)[0]);
          }
        }
        var weight = 0;
        $('input.multicrud-weight', tbody).each(function(){
          $(this).val(++weight);
        });
      };
      this.unsolidifyRow = function(tr) {
      };
      this._initRow = function(tr) {
        // console.log('initRow listener');
        // $('td.td-multicrud-weight', tr).css('display', 'none');
        return;
        if (!$('td.tabledrag-handle', tr).length) {
          $('<td class="tabledrag-handle"></td>').prependTo(tr);
        }
      };
      this.buildRow = function(tr) {
        if (!$('td.tabledrag-handle', tr).length) {
          $('<td class="tabledrag-handle"></td>').prependTo(tr);
          // $('td.multicrud-weights, td.multicrud-parents', tr).css('display', 'none');
        }
      };
      this.pruneRows = function(tr_removed, tr_remaining) {
        
      };
    })());
  });
  
  return;
  
  // add export/import
  $('tbody.multicrud-tbody').each(function(){
    var row_keeper = this.multicrud;
    var importLink = $('<a href="#">import</a>');
    var importBox = $('<div></div>');
    var importTextarea = $('<textarea></textarea>');
    importBox.prepend($('<div>').prepend(importLink));
    $(this.parentNode.parentNode).prepend(importBox);
    importLink.click(function(event){
      if (!$('textarea', importBox).size()) {
        importBox.prepend(importTextarea);
        importTextarea.focus();
      } else {
        var value_keys = row_keeper.getItemValueKeys();
        var rows = $(importTextarea).val().split('\n');
        var tabs = {};
        var id = -1;
        var indent_space = -1;
        var indent_level = -1;
        var m, indent, id, pid;
        for (var i_row=0; i_row<rows.length; ++i_row) {
          var row = rows[i_row];
          if (row.trim()) {
            m = row.match(/^( *)/);
            indent = m[0].length;
            while (indent > tabs.length) {
              tabs.push(id);
            }
            while (indent < tabs.length) {
              tabs.pop();
            }
            id = 'new-'+(i_row+1);
            pid = tabs[indent-1];
            tabs[indent] = id;
            
            var cells = row.trim().split('|');
            var values = {};
            for (var i_cell=0; i_cell<cells.length; ++i_cell) {
              if (value_keys[i_cell]) {
                values[value_keys[i_cell]] = cells[i_cell];
              }
            }
            var new_row = row_keeper.addRowWithValues(values);
            new_row.multicrud_tabledrag.pid = pid;
          }
        }
      }
      return false;
    });
  });
});
