<?php


function multicrud_submit_all($form, &$form_state) {
  if (is_array($form_state['#multicrudElements'])) {
    foreach ($form_state['#multicrudElements'] as $multicrudElement) {
      $multicrudElement->submit($form, $form_state);
    }
  }
}


function multicrud_submit($multi_element, $values, multicrud_SubmitHandler $submitHandler) {
  $keymap = $multi_element['#multicrud']['keymap'];
  // _multicrud_transform_default_values($multi_element, $keymap);
  $items = $values['items'];
  if (is_array($values['delete'])) {
    foreach ($values['delete'] as $item_key) {
      if (isset($keymap[$item_key])) {
        if ($submitHandler->deleteItem($keymap[$item_key])) {
          unset($items[$item_key]);
          if (!empty($multi_element['#multicrud_tree'])) {
            if (isset($keymap[$values['meta'][$item_key]['parent']])) {
              $keymap[$item_key] = $keymap[$values['meta'][$item_key]['parent']];
            } else {
              unset($keymap[$item_key]);
            }
          }
        }
      }
    }
  }
  $submitHandler->flushDelete();

  foreach ($items as $item_key => $item_values) {
    $meta = $values['meta'][$item_key];
    if (isset($meta['parent'])) {
      if (isset($keymap[$meta['parent']])) {
        $meta['parent'] = $keymap[$meta['parent']];
      }
      else {
        // TODO: What to do if parent failed to insert?
        $meta['parent'] = NULL;
      }
    }
    foreach (array(
      'parent' => 'parent_key',
      'weight' => 'weight_key',
    ) as $k => $kk) {
      $kkk = $multi_element['#multicrud'][$kk];
      if (!empty($kkk)) {
        if (!isset($item_values[$kkk]) && isset($meta[$k])) {
          $item_values[$kkk] = $meta[$k];
        }
      }
    }
    if (isset($keymap[$item_key])) {
      // existing item
      $submitHandler->updateItem($keymap[$item_key], $item_values, $meta);
    } else {
      $new_id = $submitHandler->insertItem($item_values, $meta);
      // TODO: What exactly do we accept as a "successful" insert id?
      if (isset($new_id) && $new_id !== FALSE && $new_id) {
        $keymap[$item_key] = $new_id;
      }
    }
  }
  $submitHandler->flush();
}


class multicrud_SubmitHandler {
  public function deleteItem($id) {
    // by default, nothing is deleted.
    return FALSE;
  }
  public function flushDelete() {
    // by default, do nothing.
  }
  public function updateItem($id, $item_values, $meta = array()) {
    // by default, nothing is updated.
  }
  public function insertItem($item_values, $meta = array()) {
    // by default, nothing is inserted.
    return NULL;
  }
  public function flush() {
    // by default, do nothing.
  }
  
  /**
   * Helper function for array insertion.
   *
   * @return
   *   Unlike the native array_push, this returns the key of the newly inserted element,
   *   not the size of the array.
   */
  protected function _array_push(&$array, $element) {
    $array[] = $element;
    end($array);
    return key($array);
  }
}





